/* tree.h - header for tree functions
 */
#ifndef TREE_H
#define TREE_H
#include "local.h"
#include "pointer.h"
#define TR_NODE struct tr_node
TR_NODE
	{
	TR_NODE *right;
	TR_NODE *left;
	/* ... */
	};
void tr_close();		/* PARMS(TR_NODE **plt) */
void tr_delete();		/* PARMS(TR_NODE **plt, TR_NODE **pln, int (*cmpfn)()) */
TR_NODE *tr_detach();	/* PARMS(TR_NODE **pln) */
void tr_insert();		/* PARMS(TR_NODE **plt, TR_NODE *pn, int (*cmpfn)()) */
TR_NODE **tr_lfind();	/* PARMS(TR_NODE **plt, TR_NODE *pn, int (*cmpfn)()) */
TR_NODE **tr_lfirst();	/* PARMS(TR_NODE **plt) */
TR_NODE **tr_lpfind();	/* PARMS(TR_NODE **plt, TR_NODE *pn, int (*cmpfn)()) */
TR_NODE **tr_lnext();	/* PARMS(TR_NODE **plt, TR_NODE *pn, int (*cmpfn)()) */

#define TR_RIGHT(p)		((p)->right)
#define TR_LEFT(p)		((p)->left)

#define TR_P(p)			PNNC(p, TR_NODE *)
#define TR_PP(p)		PNNC(p, TR_NODE **)

#define TR_CLOSE(plt)			tr_close(TR_PP(plt))
#define TR_DELETE(plt, pln, fn)	tr_delete(TR_PP(plt), TR_PP(pln), fn)
#define TR_DETACH(pln)			tr_detach(TR_PP(pln))
#define TR_INSERT(plt, pn, fn)	tr_insert(TR_PP(plt), TR_P(pn), fn)
#define TR_LFIND(plt, pn, fn)	tr_lfind(TR_PP(plt), TR_P(pn), fn)
#define TR_LFIRST(plt)			tr_lfirst(TR_PP(plt))
#define TR_LPFIND(plt, pn, fn)	tr_lpfind(TR_PP(plt), TR_P(pn), fn)
#define TR_LNEXT(plt, pn, fn)	tr_lnext(TR_PP(plt), TR_P(pn), fn)

/* true macros */
#define TR_OPEN(plt)			(*(plt) = NULL)
#define TR_FIRST(plt)			(*TR_LFIRST(plt))
#define TR_FIND(plt, pn, fn)	(*TR_LFIND(plt, pn, fn))
#define TR_NEXT(plt, pn, fn)	(*TR_LNEXT(plt, pn, fn))
#define EACH_TR(plt, p, t, fn) \
	for (p = (t *)*TR_LFIRST(plt); (p) != NULL; p = (t *)*TR_LNEXT(plt, p, fn))
#endif
